#  Copyright 2010, 2011 G24
#
#    This file is part of gpy.
#
#    gpy is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    gpy is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with gpy.  If not, see <http://www.gnu.org/licenses/>.
import main
class mod_main(main.clisten):
    """Bot administration."""
    def addcmds(self):
        self.name = "admin"
        self.cmds = {'raw':'raw','modload':'modload','modunload':'modunload','userid':'userid','usercheck':'usercheck','modreload':'modreload'}
        self.currentusers = {}
    def clisten(self):
        if (self.conn.recvinfo["cmd"] == "PART" or self.conn.recvinfo["cmd"] == "QUIT") and self.conn.recvinfo["origin"] in self.currentusers:
            del self.currentusers[self.conn.recvinfo["origin"]]
    def raw(self):
        """Send raw command to server. (Admin-only.)"""
        if self.isadmin() == False:
            self.conn.reply("Are you an administrator?")
            return
        self.conn.dispatch(self.conn.recvinfo["message.params"])
    def modreload(self):
        """Load bot modules. (Admin-only.)"""
        if self.isadmin() == False:
            self.conn.reply("Are you an administrator?")
            return
        modname = self.conn.recvinfo["message.params"]
        try:
            reload(getattr(self.conn.modules,modname))
            self.conn.mainclasses[modname] = getattr(getattr(self.conn.modules,modname),"mod_main")(self.conn)
        except Exception, e:
            self.conn.reply("Module %s reload failed. {1}"%(modname,e))
    def modload(self):
        """Load bot modules. (Admin-only.)"""
        if self.isadmin() == False:
            self.conn.reply("Are you an administrator?")
            return
        modname = self.conn.recvinfo["message.params"]
        try:
            self.conn.modules = __import__("gpy", globals(), locals(), [modname], -1)
            self.conn.mainclasses[modname] = getattr(getattr(self.conn.modules,modname),"mod_main")(self.conn)
            self.modreload()
            self.conn.reply("Module %s loaded."%modname)
        except  Exception, e:
            self.conn.reply("Module {0} not loaded. {1} ".format(modname,e))
    def modunload(self):
        """Unload bot modules. (Admin-only.)"""
        if self.isadmin() == False:
            self.conn.reply("Are you an administrator?")
            return
        modname = self.conn.recvinfo["message.params"]
        if modname in self.conn.mainclasses:
            del self.conn.mainclasses[modname]
            self.conn.reply("Module {0} unloaded successfully.".format(modname))
        else:
            self.conn.reply("Module {0} not loaded, unload operation failed.".format(modname))
    def set(self):
        """Edit bot settings. (Admin-only.)"""
    def userid(self):
        """Register, identify or log out. 'userid username pass pass' to register, 'userid username pass' to identify, 'userid username' to log out."""
        if (self.conn.recvinfo["message.params"].count(" ")) == 0: # LOG OUT
            if self.conn.recvinfo["origin"] in self.currentusers and self.currentusers[self.conn.recvinfo["origin"]] == self.conn.recvinfo["message.params"]:
                del self.currentusers[self.conn.recvinfo["origin"]]
                self.conn.reply("Logout operation success.")
            else:
                self.conn.reply("You are not {0}, logout operation failed.".format(self.conn.recvinfo["message.params"]))
        elif (self.conn.recvinfo["message.params"].count(" ")) == 1: #IDENTIFY
            user=self.conn.recvinfo["message.params"].split(" ")[0]
            pwd1=self.conn.recvinfo["message.params"].split(" ")[1]
            pwd2=self.conn.config.get("users",user)
            if pwd1 != pwd2:
                self.conn.reply("Wrong password, identify operation failed.")
            else:
                self.currentusers[self.conn.recvinfo["origin"]] = user
                self.conn.reply("Identification as {0} successful.".format(user))
        elif (self.conn.recvinfo["message.params"].count(" ")) >= 2: #REGISTER
            user = self.conn.recvinfo["message.params"].split(" ")[0]
            pwd1 = self.conn.recvinfo["message.params"].split(" ")[1]
            pwd2 = self.conn.recvinfo["message.params"].split(" ")[2]
            if pwd1 != pwd2:
                self.conn.reply("Passwords do not match, register operation failed.")
            else:
                self.conn.config.set("users",user,pwd1)
                self.conn.writeconfig()
                self.conn.reply("User '{0}' with password '{1}' added, register operation successful.".format(user,pwd1))
                del user
                del pwd1
                del pwd2
    def usercheck(self):
        """'usercheck me' to display your level; 'usercheck username level' to change level (admin-only)"""
        if (self.conn.recvinfo["message.params"].count(" ")) == 0: # 1 param ("me")
            if self.conn.recvinfo["origin"] in self.currentusers:
                r = "You are {0}.".format(self.currentusers[self.conn.recvinfo["origin"]])
                if self.conn.config.has_option("admins",self.currentusers[self.conn.recvinfo["origin"]]):
                    r = r + " You are an admin."
                self.conn.reply(r)
                del r
            else:
                self.conn.reply("You're not identified. You can identify using 'userid' command.")
        elif (self.conn.recvinfo["message.params"].count(" ")) == 1: # 2 params (username, level)
            if self.conn.recvinfo["origin"] in self.currentusers:
                username = self.currentusers[self.conn.recvinfo["origin"]] # SAYER'S USERNAME IN THE BOT
                if self.conn.config.has_option("admins",username):
                    if self.conn.recvinfo["message.params"].split(" ")[1] == "admin":
                        self.conn.config.set("admins",self.conn.recvinfo["message.params"].split(" ")[0],"")
                        self.conn.writeconfig()
                        self.conn.reply("{0} added to admins.".format(self.conn.recvinfo["message.params"].split(" ")[0]))
                    else:
                        if self.conn.config.has_option("admins",self.conn.recvinfo["message.params"].split(" ")[0]) == False:
                            self.conn.reply("{0} isn't an admin yet.".format(self.conn.recvinfo["message.params"].split(" ")[0]))
                        else:
                            self.conn.config.remove_option("admins",self.conn.recvinfo["message.params"].split(" ")[0])
                            self.conn.writeconfig()
                            self.conn.reply("{0} removed from admins.".format(self.conn.recvinfo["message.params"].split(" ")[0]))
                else:
                    self.conn.reply("You are not an admin.")
            else:
                self.conn.reply("You're not logged in.")
    def isadmin(self):
        if self.conn.recvinfo["origin"] in self.currentusers:
            if self.conn.config.has_option("admins",self.currentusers[self.conn.recvinfo["origin"]]):
                return True
            else:
                return False
        else:
            return False
