#  Copyright 2010, 2011 G24
#
#    This file is part of gpy.
#
#    gpy is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    gpy is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with gpy.  If not, see <http://www.gnu.org/licenses/>.

import main
import re

class mod_main(main.clisten):
    """Fact module. Remember words and look them up. """
    def addcmds(self):
        self.name = "fact"
        self.cmds = {"?":"fact","?l":"listfact"}
        # MAKING THE DICT
        self.dict = {}
        try:
            with open('dict', 'r') as f:
                if f == None:
                    f.write("")
                while True:
                    l = f.readline()
                    if(len(l) == 0):
                        break
                    self.dict[l.split('=')[0]] = '='.join(l.split('=')[1:]).replace('\n','')
        except:
            with open('dict', 'w') as f:
                f.write("")
        self.conn.ok(str(self.dict))
    def clisten(self):
        try:
            try:
                msgcmd = self.conn.recvinfo["message"].split(' ')[3]
            except Exception,e:
                return
            msgparams = self.conn.recvinfo["message.params"]
            if msgcmd == "INFOBOT:QUERY":
                self.conn.pm("INFOBOT:REPLY 0 {0} = {1}".format(msgparams,self.dict[msgparams]))
        except Exception, e:
            self.conn.pm("INFOBOT:DUNNO 0 {0}".format(self.conn.recvinfo["message.params"]))
    def fact(self): 
        '''Factoids, delimiter '='.'''
        if self.conn.recvinfo["message.params"].find("=") == -1: # SAY
            try:
                self.conn.reply(str(self.dict[self.conn.recvinfo["message.params"]]))
            except:
                self.conn.reply('I do not know {0}.'.format(self.conn.recvinfo["message.params"]))
                pass
        elif self.conn.recvinfo["message.params"].split("=")[1].strip() == "": # DELETE
            fact = self.conn.recvinfo["message.params"].split("=")[0].strip()
            try:
                del self.dict[fact]
                f = open('dict', 'w')
                for item in self.dict:
                    f.write(item + ' ' + self.dict[item]+'\n')
                f.close()
                self.conn.reply("I forgot {0}.".format(fact))
            except Exception, e:
                print e
        else: # ADD
            fact = self.conn.recvinfo["message.params"].split("=")[0].strip()
            value = "=".join(self.conn.recvinfo["message.params"].split("=")[1:]).strip()
            if fact in self.dict:
                self.conn.reply("I already know {0}. {1}..".format(fact, self.dict[fact]))
                return
            else:    
                f = open('dict', 'a')
                f.write(fact + '=' + value + "\n")
                f.close()
                self.dict[fact] = value
                self.conn.reply("ok")
    def listfact(self):
        """Lists current factoids by regexp. ex: `?l all f` for the ones containing 'f' or 'F'; `?l all` for a complete list."""
        tmp = "I know "
        try:
            self.exp = self.conn.recvinfo["message.params"].split(" ")[1]
        except:
            self.exp = ""
        for each in self.dict.keys():
            print each
            if(re.search(self.exp.lower(),each.lower())) != None:
                tmp=tmp + each.strip() + ", "
        del self.exp
        self.conn.reply(tmp + "see also " + self.conn.config.get("me","char") + "?")

